<?xml version="1.0" encoding="UTF-8"?>
<?altova_samplexml file:///D:/Schematron/XNAT/protocol.report.xml?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions" xmlns:validate="http://nrg.wustl.edu/validate" xmlns:xnat="http://nrg.wustl.edu/xnat" xmlns:svrl="http://purl.oclc.org/dsdl/svrl" xmlns:nrgxsl="http://nrg.wustl.edu/validate" xmlns:prov="http://www.nbirn.net/prov" xmlns:ext="org.nrg.validate.utils.ProvenanceUtils">
<xsl:output method="xml" indent="yes" />
<!-- Pass the following parameters on the commandline. These are used for provenance-->
<xsl:param name="reportfilename"/>
<xsl:param name="rulefilename"/>
<xsl:param name="rulexslfilename"/>
<xsl:param name="xslfilename"/>
<xsl:param name="uri_content"/>


<xsl:param name="experimentfilename"/>
<xsl:param name="validationfilename"/>
<xsl:param name="validationxslfilename"/>
 
<xsl:param name="now-date"><xsl:value-of select="ext:GetDate()"/></xsl:param>
<xsl:param name="now-time"><xsl:value-of select="ext:GetTime()"/></xsl:param>
 <xsl:param name="xml-dateTime"><xsl:value-of select="concat($now-date,'T',$now-time)"/></xsl:param>
<xsl:template match="/">
<xsl:message>Generating Validation Document</xsl:message>
<xsl:message>ReportFileName <xsl:value-of select="$reportfilename" /></xsl:message>
<xsl:message>RuleFileName <xsl:value-of select="$rulefilename" /></xsl:message>
<xsl:message>RuleXSLFileName <xsl:value-of select="$rulexslfilename" /></xsl:message>
<xsl:message>XSLFileName <xsl:value-of select="$xslfilename" /></xsl:message>
<xsl:message>ExperimentFileName <xsl:value-of select="$experimentfilename" /></xsl:message>
<xsl:message>ValidationFileName <xsl:value-of select="$validationfilename" /></xsl:message>
<xsl:message>ValidationXSLFileName <xsl:value-of select="$validationxslfilename" /></xsl:message>


	<validate:ImageSessionValidation>
	<xsl:attribute name="ID">
       <xsl:value-of select="concat(/svrl:schematron-output/svrl:successful-report[@id='expt_id']/svrl:text,'_Validation_',$now-date)"/>
	</xsl:attribute>
	<xsl:attribute name="project">
       <xsl:value-of select="/svrl:schematron-output/svrl:successful-report[@id='expt_project']/svrl:text"/>
	</xsl:attribute>
	<xnat:date><xsl:value-of select="$now-date"/></xnat:date>
	<xnat:time><xsl:value-of select="$now-time"/></xnat:time>
	<xnat:validation>
		<xsl:choose>
		<xsl:when test="count(/svrl:schematron-output/svrl:failed-assert)>0">
				<xsl:attribute name="status">fail</xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
				<xsl:attribute name="status">pass</xsl:attribute>
		</xsl:otherwise>
	   </xsl:choose>
		<xnat:notes>
		<xsl:value-of select="//nrgxsl:acquisition/text()"/>
		</xnat:notes>
	</xnat:validation>
	<xnat:provenance>
<prov:processStep>
<prov:program>
				<xsl:attribute name="arguments"><xsl:value-of select="concat('-o ', $rulexslfilename,'  ',  $rulefilename, '   ', $xslfilename)"></xsl:value-of></xsl:attribute>
 validation-transform	
</prov:program>
				<prov:timestamp><xsl:value-of select="$xml-dateTime"/></prov:timestamp>
				<prov:user><xsl:value-of select="ext:GetUser()"/></prov:user>
				<prov:machine><xsl:value-of select="ext:GetHostName()"/></prov:machine>
				<prov:platform>
					<xsl:attribute name="version"><xsl:value-of select="ext:GetOsVersion()"/></xsl:attribute>
				<xsl:value-of select="ext:GetOsName()"/></prov:platform>
</prov:processStep>	
<prov:processStep>
<prov:program>
				<xsl:attribute name="arguments"><xsl:value-of select="concat('-o ', $reportfilename,'  ',  $experimentfilename, '   ', $xslfilename)"></xsl:value-of></xsl:attribute>
 validation-transform	
</prov:program>
				<prov:timestamp><xsl:value-of select="$xml-dateTime"/></prov:timestamp>
				<prov:user><xsl:value-of select="ext:GetUser()"/></prov:user>
				<prov:machine><xsl:value-of select="ext:GetHostName()"/></prov:machine>
				<prov:platform>
					<xsl:attribute name="version"><xsl:value-of select="ext:GetOsVersion()"/></xsl:attribute>
				<xsl:value-of select="ext:GetOsName()"/></prov:platform>
</prov:processStep>	
<prov:processStep>
<prov:program>
				<xsl:attribute name="arguments"><xsl:value-of select="concat('-o ', $validationfilename,'   ', $reportfilename,'  ', $validationxslfilename,' rulefilename=',$rulefilename,' reportfilename=',$reportfilename,' rulexslfilename=',$rulexslfilename,' experimentfilename=',$experimentfilename,' validationfilename=',$validationfilename,' xslfilename=',$xslfilename,' validationxslfilename=',$validationxslfilename,' uri_content=',$uri_content)"/></xsl:attribute>
validation-transform
</prov:program>
				<prov:timestamp><xsl:value-of select="$xml-dateTime"/></prov:timestamp>
				<prov:user><xsl:value-of select="ext:GetUser()"/></prov:user>
				<prov:machine><xsl:value-of select="ext:GetHostName()"/></prov:machine>
				<prov:platform>
					<xsl:attribute name="version"><xsl:value-of select="ext:GetOsVersion()"/></xsl:attribute>
				<xsl:value-of select="ext:GetOsName()"/></prov:platform>
</prov:processStep>	
	</xnat:provenance>
	<xnat:imageSession_ID>
			<xsl:value-of select="/svrl:schematron-output/svrl:successful-report[@id='expt_id']/svrl:text"/>
		</xnat:imageSession_ID>
<validate:scans>
		 <xsl:for-each select="//nrgxsl:scans">
			<xsl:call-template name="process-scan">
				<xsl:with-param name="scan-id" select="normalize-space(.)" />
			</xsl:call-template>
	 	  </xsl:for-each>
</validate:scans>	
	</validate:ImageSessionValidation>
	<xsl:message>DONE</xsl:message>
</xsl:template>

<xsl:template name="process-scan">
	<xsl:param name="scan-id"/>
	    <validate:scan ID="{$scan-id}">
		          <xsl:choose>
			      <xsl:when test="count(/svrl:schematron-output/svrl:failed-assert/svrl:text/nrgxsl:scan[@id=$scan-id])>0">
			          <validate:validationStatus>fail</validate:validationStatus>
			      </xsl:when>
			      <xsl:otherwise>
			       <validate:validationStatus>pass</validate:validationStatus>
			      </xsl:otherwise>
				</xsl:choose>
			<validate:comments>
				<xsl:for-each select="//nrgxsl:scan[@id=$scan-id]">
				   <xsl:value-of select="."/>.
				</xsl:for-each> 
	 	       </validate:comments>
		    </validate:scan>
</xsl:template>

</xsl:stylesheet>
